<template>
  <div class="container extended pt-5 pb-5">
    <b-form @submit.prevent="submitLogin()">
      <b-form-group label="username" label-for="input-username">
        <b-form-input
          id="input-username"
          v-model="form.username"
          trim
        ></b-form-input>
      </b-form-group>

      <b-form-group label="password" label-for="input-password">
        <b-form-input
          id="input-password"
          v-model="form.password"
          type="password"
          trim
        ></b-form-input>
      </b-form-group>

      <b-button :disabled="!formValid" variant="success" type="submit"
        >login</b-button
      >
    </b-form>

    <b-alert :show="error" variant="danger" class="mt-4">
      login failed
    </b-alert>
  </div>
</template>

<script>
export default {
  auth: 'guest',
  data() {
    return {
      error: null,
      form: {
        username: '',
        password: '',
      },
    };
  },
  computed: {
    formValid() {
      return this.form.username !== '' && this.form.password !== '';
    },
  },
  methods: {
    submitLogin() {
      if (this.formValid) {
        this.login();
      }
    },
    async login() {
      await this.$auth
        .loginWith('jwt', {
          data: {
            username: this.form.username,
            password: this.form.password,
          },
        })
        // eslint-disable-next-line handle-callback-err
        .catch((error) => {
          this.error = true;
          // this.$store.dispatch('error/errorHandle', error);
        });
    },
  },
};
</script>
